package jp.gihyo.mitoma.android.s1601recycerview;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.recyclerview.widget.RecyclerView;

import org.jspecify.annotations.NonNull;

import java.util.ArrayList;

public class MyAdapter extends RecyclerView.Adapter<MyAdapter.ViewHolder> {

    private ArrayList<FriendsDTO> friendsList;
    private ArrayList<Integer> imageList;
    private View.OnClickListener listener;
    private View.OnLongClickListener longListener;

    // コンストラクタで表示データを受け取る
    public MyAdapter(ArrayList<FriendsDTO> friendsList,ArrayList<Integer> imageList) {

        this.friendsList = friendsList;
        this.imageList = imageList;
    }
    // クリックリスナーのセッター
    public void setOnMyClickListener(View.OnClickListener listener){

        this.listener = listener;
    }
    public void setOnMyClickListener(View.OnLongClickListener longListener){
        this.longListener = longListener;
    }
    // ***** 以下必須メソッド *****************************************************
    @NonNull
    @Override
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        // 1行分のレイアウトを生成
        View itemView = LayoutInflater.from(parent.getContext())
                .inflate(R.layout.item_layout, parent, false);
        return new ViewHolder(itemView,listener,longListener);
    }

    @Override
    public void onBindViewHolder(@NonNull ViewHolder holder, int position) {
        // 指定位置のデータをTextViewに設定
        FriendsDTO dto = friendsList.get(position);
        int imageNo = imageList.get(position);
        holder.friendImage.setImageResource(imageNo);
        holder.tvID.setText(dto.id);
        holder.tvName.setText(dto.name);
        holder.tvPhone.setText(dto.phone);
        // クリック
        holder.tvName.setOnClickListener(listener);
        holder.itemView.setOnLongClickListener(longListener);

    }
    public int getItemCount() {
        return friendsList.size();
    }
    // --- ViewHolder クラス ---
    public static class ViewHolder extends RecyclerView.ViewHolder {
        ImageView friendImage;
        TextView tvID;
        TextView tvName;
        TextView tvPhone;
        public ViewHolder(@NonNull View itemView,View.OnClickListener listener,
                          View.OnLongClickListener longListener) {
            super(itemView);
            friendImage = itemView.findViewById(R.id.memberImage);
            tvID = itemView.findViewById(R.id.tvID);
            tvName = itemView.findViewById(R.id.tvName);
            tvPhone = itemView.findViewById(R.id.tvPhone);
            // 行にロングリスナーを設定
            itemView.setOnLongClickListener(longListener);
            // 名前にリスナーを設定
            tvName.setOnClickListener(listener);
        }
    }
}